/* --- Copyright University of Birmingham 2011. All rights reserved. ------
 > File:			$usepop/pop/lib/auto/nostring_readline.p
 > Purpose:			Redefine readline so as to ignore string quotes and work
					in editor buffer. See LIB EMACSREADLINE
 >					TEACH number-rulebase.p
 > Author:			Aaron Sloman, 9 Dec 2011
 > Documentation: 	
 > Related Files:   LIB stroppy, $usepop/pop/packages/prb/auto/rdl.p
 */



section;


;;; don't recompile
unless identprops("nostring_readline_orig") = undef then
	[endsection;] -> proglist;
endunless;

global constant nostring_readline_orig = readline;


define vars nostring_readline();
	lvars item, list;
	dlocal popprompt = pop_readline_prompt, popnewline, proglist;
	
	define lconstant repeater();
		;;; special character repeater to suppress string quotes
		;;; and null characters (needed?)
		lvars char = charin();
		;;; ignore string quotes and null characters
		while char == 0 or char == `'` do charin() -> char endwhile;
		if char == `\n` or char == termin then
			termin
		else
			uppertolower(char)
		endif
	enddefine;

	pdtolist(incharitem(repeater)) -> proglist;

	true -> popnewline;
	[%
		until null(proglist)
		or (dest(proglist) -> (item, proglist); item == newline or item == termin)
		do
			item
	   	enduntil
	%] -> list;
	if list == [] and item == termin then termin else list endif;
enddefine;


endsection;
